



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>android Gui系统之SurfaceFlinger(2)---BufferQueue</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">android Gui系统之SurfaceFlinger(2)---BufferQueue</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 09:12:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>6 BufferQueue</h3>
<p>上一篇已经说到，BufferQueue是SurfaceFlinger管理和消费surface的中介，我们就开始分析bufferqueue。</p>
<p>每个应用 可以由几个BufferQueue？</p>
<p>应用绘制UI 所需的内存从何而来？</p>
<p>应用和SurfaceFlinger 如何互斥共享资源的访问？</p>
<h4>6.1 Buffer的状态</h4>
<div>
<pre class="prettyprint linenums">const char* BufferSlot::bufferStateName(BufferState state) {<br />
    switch (state) {<br />
        case BufferSlot::DEQUEUED: return "DEQUEUED";<br />
        case BufferSlot::QUEUED: return "QUEUED";<br />
        case BufferSlot::FREE: return "FREE";<br />
        case BufferSlot::ACQUIRED: return "ACQUIRED";<br />
        default: return "Unknown";<br />
    }<br />
}</pre>
</div>
<p>状态变迁如下：FREE-&gt;DEQUEUED-&gt;QUEUED-&gt;ACQUIRED-&gt;FREE</p>
<p>BufferQueue的状态迁移图：</p>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/2187677-6ec6238be08a7877.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>我们先来看，producer &amp; comsumer 分别是什么？</div>
<div>应用程序需要刷新UI，所以就会产生surface到BufferQueue，so，producer 可以认为就是应用程序，也可以是上一篇里面介绍的ISurfaceComposerClient。</div>
<div>comsumer不用看也知道，就是SurfaceFlinger。所以可以明确一个大致的流程就是，</div>
<div>1）应用需要刷新UI，获取一个buffer的缓冲区，这个操作就是dequeue。经过dequeue以后，该buffer被producer锁定，其他Owner就不能插手了。</div>
<div>2）然后把surface写入到该buffer里面，当producer认为写入结束后，就执行queue的操作，把buffer 归还给bufferqueue。Owner也变成为bufferqueue。</div>
<div>3）当一段buffer里面由数据以后，comsumer就会收到消息，然后去获取该buffer。</div>
<div>
<div>
<pre class="prettyprint linenums">void BufferQueue::ProxyConsumerListener::onFrameAvailable(<br />
        const android::BufferItem&amp; item) {<br />
    sp&lt;ConsumerListener&gt; listener(mConsumerListener.promote());<br />
    if (listener != NULL) {<br />
        listener-&gt;onFrameAvailable(item);<br />
    }<br />
}</pre>
</div>
<p>bufferqueue里面就是comsumerlistener，当有可以使用的buffer后，就会通知comsumer使用。</p>
<div>
<pre class="prettyprint linenums">// mGraphicBuffer points to the buffer allocated for this slot or is NULL<br />
    // if no buffer has been allocated.<br />
    sp&lt;GraphicBuffer&gt; mGraphicBuffer;</pre>
</div>
<p>可以看到注释，bufferqueue的mSlot[64],并不是都有内容的，也就是mSlot存的是buferr的指针，如果没有，就存null</p>
<p>slot的个数在andorid5.0 里面定义在BufferQueueDefs.h里面，</p>
<div>
<pre class="prettyprint linenums"> enum { NUM_BUFFER_SLOTS =  };</pre>
</div>
<h4>6.2 Buffer内存的出处</h4>
<p>既然producer是主动操作，所以如果在dequeue的时候，已经获取了内存，后面的操作也就不需要分配内存了。</p>
<div>
<div>
<pre class="prettyprint linenums">status_t BufferQueueProducer::dequeueBuffer(int *outSlot,<br />
        sp&lt;android::Fence&gt; *outFence, bool async,<br />
        uint32_t width, uint32_t height, uint32_t format, uint32_t usage) {<br />
    ATRACE_CALL();<br />
    { // Autolock scope<br />
        Mutex::Autolock lock(mCore-&gt;mMutex);<br />
        mConsumerName = mCore-&gt;mConsumerName;<br />
    } // Autolock scope

    BQ_LOGV("dequeueBuffer: async=%s w=%u h=%u format=%#x, usage=%#x",<br />
            async ? "true" : "false", width, height, format, usage);

    if ((width &amp;&amp; !height) || (!width &amp;&amp; height)) {<br />
        BQ_LOGE("dequeueBuffer: invalid size: w=%u h=%u", width, height);<br />
        return BAD_VALUE;<br />
    }

    status_t returnFlags = NO_ERROR;<br />
    EGLDisplay eglDisplay = EGL_NO_DISPLAY;<br />
    EGLSyncKHR eglFence = EGL_NO_SYNC_KHR;<br />
    bool attachedByConsumer = false;

    { // Autolock scope<br />
        Mutex::Autolock lock(mCore-&gt;mMutex);<br />
        mCore-&gt;waitWhileAllocatingLocked();

        if (format == ) {<br />
            format = mCore-&gt;mDefaultBufferFormat;<br />
        }

        // Enable the usage bits the consumer requested<br />
        usage |= mCore-&gt;mConsumerUsageBits;

        int found;<br />
        status_t status = waitForFreeSlotThenRelock("dequeueBuffer", async,<br />
                &amp;found, &amp;returnFlags);<br />
        if (status != NO_ERROR) {<br />
            return status;<br />
        }

        // This should not happen<br />
        if (found == BufferQueueCore::INVALID_BUFFER_SLOT) {<br />
            BQ_LOGE("dequeueBuffer: no available buffer slots");<br />
            return -EBUSY;<br />
        }

        *outSlot = found;<br />
        ATRACE_BUFFER_INDEX(found);

        attachedByConsumer = mSlots[found].mAttachedByConsumer;

        const bool useDefaultSize = !width &amp;&amp; !height;<br />
        if (useDefaultSize) {<br />
            width = mCore-&gt;mDefaultWidth;<br />
            height = mCore-&gt;mDefaultHeight;<br />
        }

        mSlots[found].mBufferState = BufferSlot::DEQUEUED;

        const sp&lt;GraphicBuffer&gt;&amp; buffer(mSlots[found].mGraphicBuffer);<br />
        if ((buffer == NULL) ||<br />
                (static_cast&lt;uint32_t&gt;(buffer-&gt;width) != width) ||<br />
                (static_cast&lt;uint32_t&gt;(buffer-&gt;height) != height) ||<br />
                (static_cast&lt;uint32_t&gt;(buffer-&gt;format) != format) ||<br />
                ((static_cast&lt;uint32_t&gt;(buffer-&gt;usage) &amp; usage) != usage))<br />
        {<br />
            mSlots[found].mAcquireCalled = false;<br />
            mSlots[found].mGraphicBuffer = NULL;<br />
            mSlots[found].mRequestBufferCalled = false;<br />
            mSlots[found].mEglDisplay = EGL_NO_DISPLAY;<br />
            mSlots[found].mEglFence = EGL_NO_SYNC_KHR;<br />
            mSlots[found].mFence = Fence::NO_FENCE;

            returnFlags |= BUFFER_NEEDS_REALLOCATION;<br />
        }

        if (CC_UNLIKELY(mSlots[found].mFence == NULL)) {<br />
            BQ_LOGE("dequeueBuffer: about to return a NULL fence - "<br />
                    "slot=%d w=%d h=%d format=%u",<br />
                    found, buffer-&gt;width, buffer-&gt;height, buffer-&gt;format);<br />
        }

        eglDisplay = mSlots[found].mEglDisplay;<br />
        eglFence = mSlots[found].mEglFence;<br />
        *outFence = mSlots[found].mFence;<br />
        mSlots[found].mEglFence = EGL_NO_SYNC_KHR;<br />
        mSlots[found].mFence = Fence::NO_FENCE;<br />
    } // Autolock scope

    if (returnFlags &amp; BUFFER_NEEDS_REALLOCATION) {<br />
        status_t error;<br />
        BQ_LOGV("dequeueBuffer: allocating a new buffer for slot %d", *outSlot);<br />
        sp&lt;GraphicBuffer&gt; graphicBuffer(mCore-&gt;mAllocator-&gt;createGraphicBuffer(<br />
                    width, height, format, usage, &amp;error));<br />
        if (graphicBuffer == NULL) {<br />
            BQ_LOGE("dequeueBuffer: createGraphicBuffer failed");<br />
            return error;<br />
        }

        { // Autolock scope<br />
            Mutex::Autolock lock(mCore-&gt;mMutex);

            if (mCore-&gt;mIsAbandoned) {<br />
                BQ_LOGE("dequeueBuffer: BufferQueue has been abandoned");<br />
                return NO_INIT;<br />
            }

            mSlots[*outSlot].mFrameNumber = UINT32_MAX;<br />
            mSlots[*outSlot].mGraphicBuffer = graphicBuffer;<br />
        } // Autolock scope<br />
    }

    if (attachedByConsumer) {<br />
        returnFlags |= BUFFER_NEEDS_REALLOCATION;<br />
    }

    if (eglFence != EGL_NO_SYNC_KHR) {<br />
        EGLint result = eglClientWaitSyncKHR(eglDisplay, eglFence, ,<br />
                );<br />
        // If something goes wrong, log the error, but return the buffer without<br />
        // synchronizing access to it. It's too late at this point to abort the<br />
        // dequeue operation.<br />
        if (result == EGL_FALSE) {<br />
            BQ_LOGE("dequeueBuffer: error %#x waiting for fence",<br />
                    eglGetError());<br />
        } else if (result == EGL_TIMEOUT_EXPIRED_KHR) {<br />
            BQ_LOGE("dequeueBuffer: timeout waiting for fence");<br />
        }<br />
        eglDestroySyncKHR(eglDisplay, eglFence);<br />
    }

    BQ_LOGV("dequeueBuffer: returning slot=%d/%" PRIu64 " buf=%p flags=%#x",<br />
            *outSlot,<br />
            mSlots[*outSlot].mFrameNumber,<br />
            mSlots[*outSlot].mGraphicBuffer-&gt;handle, returnFlags);

    return returnFlags;<br />
}</pre>
</div>
<p>dequeueBuffer</p></div>
<p>step1：BufferQueueProducer::waitForFreeSlotThenRelock 循环的主要作用就是查找可以使用的slot。</p>
<p>step2：释放不需要的buffer，并且统计已分配的内存。</p>
<div>
<pre class="prettyprint linenums">        // Free up any buffers that are in slots beyond the max buffer count<br />
        for (int s = maxBufferCount; s &lt; BufferQueueDefs::NUM_BUFFER_SLOTS; ++s) {<br />
            assert(mSlots[s].mBufferState == BufferSlot::FREE);<br />
            if (mSlots[s].mGraphicBuffer != NULL) {<br />
                mCore-&gt;freeBufferLocked(s);<br />
                *returnFlags |= RELEASE_ALL_BUFFERS;<br />
            }<br />
        }</pre>
</div>
<div>
<pre class="prettyprint linenums">for (int s = ; s &lt; maxBufferCount; ++s) {<br />
            switch (mSlots[s].mBufferState) {<br />
                case BufferSlot::DEQUEUED:<br />
                    ++dequeuedCount;<br />
                    break;<br />
                case BufferSlot::ACQUIRED:<br />
                    ++acquiredCount;<br />
                    break;<br />
                case BufferSlot::FREE:<br />
                    // We return the oldest of the free buffers to avoid<br />
                    // stalling the producer if possible, since the consumer<br />
                    // may still have pending reads of in-flight buffers<br />
                    if (*found == BufferQueueCore::INVALID_BUFFER_SLOT ||<br />
                            mSlots[s].mFrameNumber &lt; mSlots[*found].mFrameNumber) {<br />
                        <strong>*found =</strong><strong> s;</strong><br />
                    }<br />
                    break;<br />
                default:<br />
                    break;<br />
            }<br />
        }</pre>
</div>
<p>如果有合适的，found 就是可以使用的buffer编号。</p>
<p>如果dequeue too many，but comsumer还来不及消耗掉，这个时候，有可能会导致OOM，所以，判断是否在队列里面有过多的buffer。</p>
<p>等待comsumer消耗后，释放互斥锁。</p>
<div>
<pre class="prettyprint linenums">        if (tryAgain) {<br />
            // Return an error if we're in non-blocking mode (producer and<br />
            // consumer are controlled by the application).<br />
            // However, the consumer is allowed to briefly acquire an extra<br />
            // buffer (which could cause us to have to wait here), which is<br />
            // okay, since it is only used to implement an atomic acquire +<br />
            // release (e.g., in GLConsumer::updateTexImage())<br />
            if (mCore-&gt;mDequeueBufferCannotBlock &amp;&amp;<br />
                    (acquiredCount &lt;= mCore-&gt;mMaxAcquiredBufferCount)) {<br />
                return WOULD_BLOCK;<br />
            }<br />
            mCore-&gt;mDequeueCondition.wait(mCore-&gt;mMutex);<br />
        }</pre>
</div>
<p>在返回dqueueBuffer这个方法：如果没有找到free的slot，就直接返回错误。当然正常情况下是不会发生的。</p>
<div>
<pre class="prettyprint linenums">        // This should not happen<br />
        if (found == BufferQueueCore::INVALID_BUFFER_SLOT) {<br />
            BQ_LOGE("dequeueBuffer: no available buffer slots");<br />
            return -EBUSY;<br />
        }</pre>
</div>
<div>
<pre class="prettyprint linenums"> mSlots[found].mBufferState = BufferSlot::DEQUEUED;</pre>
</div>
<p>把找到的buffer的状态设为DEQUEUE。</p>
<p>在判断了mSlot[found]的属性以后，它可能是空的，也有可能不符合当前需要的buffer的size，就给mSlot[found]分配新的属性和内存</p>
<div>
<pre class="prettyprint linenums">if ((buffer == NULL) ||<br />
                (static_cast&lt;uint32_t&gt;(buffer-&gt;width) != width) ||<br />
                (static_cast&lt;uint32_t&gt;(buffer-&gt;height) != height) ||<br />
                (static_cast&lt;uint32_t&gt;(buffer-&gt;format) != format) ||<br />
                ((static_cast&lt;uint32_t&gt;(buffer-&gt;usage) &amp; usage) != usage))<br />
        {<br />
            mSlots[found].mAcquireCalled = false;<br />
            mSlots[found].mGraphicBuffer = NULL;<br />
            mSlots[found].mRequestBufferCalled = false;<br />
            mSlots[found].mEglDisplay = EGL_NO_DISPLAY;<br />
            mSlots[found].mEglFence = EGL_NO_SYNC_KHR;<br />
            mSlots[found].mFence = Fence::NO_FENCE;

            returnFlags |= BUFFER_NEEDS_REALLOCATION;<br />
        }

        if (CC_UNLIKELY(mSlots[found].mFence == NULL)) {<br />
            BQ_LOGE("dequeueBuffer: about to return a NULL fence - "<br />
                    "slot=%d w=%d h=%d format=%u",<br />
                    found, buffer-&gt;width, buffer-&gt;height, buffer-&gt;format);<br />
        }

        eglDisplay = mSlots[found].mEglDisplay;<br />
        eglFence = mSlots[found].mEglFence;<br />
        *outFence = mSlots[found].mFence;<br />
        mSlots[found].mEglFence = EGL_NO_SYNC_KHR;<br />
        mSlots[found].mFence = Fence::NO_FENCE;<br />
    } // Autolock scope

    if (returnFlags &amp; BUFFER_NEEDS_REALLOCATION) {<br />
        status_t error;<br />
        BQ_LOGV("dequeueBuffer: allocating a new buffer for slot %d", *outSlot);<br />
        sp&lt;GraphicBuffer&gt; graphicBuffer(mCore-&gt;mAllocator-&gt;createGraphicBuffer(<br />
                    width, height, format, usage, &amp;error));<br />
        if (graphicBuffer == NULL) {<br />
            BQ_LOGE("dequeueBuffer: createGraphicBuffer failed");<br />
            return error;<br />
        }

        { // Autolock scope<br />
            Mutex::Autolock lock(mCore-&gt;mMutex);

            if (mCore-&gt;mIsAbandoned) {<br />
                BQ_LOGE("dequeueBuffer: BufferQueue has been abandoned");<br />
                return NO_INIT;<br />
            }

            mSlots[*outSlot].mFrameNumber = UINT32_MAX;<br />
            mSlots[*outSlot].mGraphicBuffer = graphicBuffer;<br />
        } // Autolock scope<br />
    }</pre>
</div>
<p>这样buffer对应的内存就是在producer，dequeue操作的时候分配内存的。（if need）</p>
<h4>6.3应用程序和BufferQueue的关系</h4>
<p>首先看一张surface各类之间的关系：</p>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/2187677-e1977d6c1d92a748.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>
<div>&nbsp;这里多了一个Layer的东西，Layer代表一个画面的图层（在android app的角度以前是没有图层的概念的，虽然framework有）。</div>
<div>SurfaceFlinger混合，就是把所有的layer做混合。</div>
<div>我们先来看createlayer：</div>
<div>
<div>
<pre class="prettyprint linenums">status_t SurfaceFlinger::createLayer(<br />
        const String8&amp; name,<br />
        const sp&lt;Client&gt;&amp; client,<br />
        uint32_t w, uint32_t h, PixelFormat format, uint32_t flags,<br />
        sp&lt;IBinder&gt;* handle, sp&lt;IGraphicBufferProducer&gt;* gbp)</pre>
</div>
<p>这里关键是handler &amp; gbp这2个参数。</p>
<p>我们看下去代码：layer 是从createNormalLayer里面来的</p>
<div>
<pre class="prettyprint linenums">status_t SurfaceFlinger::createNormalLayer(const sp&lt;Client&gt;&amp; client,<br />
        const String8&amp; name, uint32_t w, uint32_t h, uint32_t flags, PixelFormat&amp; format,<br />
        sp&lt;IBinder&gt;* handle, sp&lt;IGraphicBufferProducer&gt;* gbp, sp&lt;Layer&gt;* outLayer)<br />
{<br />
    // initialize the surfaces<br />
    switch (format) {<br />
    case PIXEL_FORMAT_TRANSPARENT:<br />
    case PIXEL_FORMAT_TRANSLUCENT:<br />
        format = PIXEL_FORMAT_RGBA_8888;<br />
        break;<br />
    case PIXEL_FORMAT_OPAQUE:<br />
        format = PIXEL_FORMAT_RGBX_8888;<br />
        break;<br />
    }

    *outLayer = new Layer(this, client, name, w, h, flags);<br />
    status_t err = (*outLayer)-&gt;setBuffers(w, h, format, flags);<br />
    if (err == NO_ERROR) {<br />
        <strong>*handle = (*outLayer)-&gt;getHandle();<br />
        *gbp = (*outLayer)-&gt;</strong><strong>getProducer();</strong><br />
    }

    ALOGE_IF(err, "createNormalLayer() failed (%s)", strerror(-err));<br />
    return err;<br />
}</pre>
</div>
<p>producer跟踪源代码可以看到：</p>
<div>
<pre class="prettyprint linenums">class MonitoredProducer : public IGraphicBufferProducer </pre>
</div>
<p>通过bind机制，可以认为就是BufferQueue的一个子类。</p>
<p>所以，每一个bufferqueue对应的都是一个layer。</p>
<p>看下handler：</p>
<div>
<pre class="prettyprint linenums">sp&lt;IBinder&gt; Layer::getHandle() {<br />
    Mutex::Autolock _l(mLock);

    LOG_ALWAYS_FATAL_IF(mHasSurface,<br />
            "Layer::getHandle() has already been called");

    mHasSurface = true;

    /*<br />
     * The layer handle is just a BBinder object passed to the client<br />
     * (remote process) -- we don't keep any reference on our side such that<br />
     * the dtor is called when the remote side let go of its reference.<br />
     *<br />
     * LayerCleaner ensures that mFlinger-&gt;onLayerDestroyed() is called for<br />
     * this layer when the handle is destroyed.<br />
     */

    class Handle : public BBinder, public LayerCleaner {<br />
        wp&lt;const Layer&gt; mOwner;<br />
    public:<br />
        Handle(const sp&lt;SurfaceFlinger&gt;&amp; flinger, const sp&lt;Layer&gt;&amp; layer)<br />
            : LayerCleaner(flinger, layer), mOwner(layer) {<br />
        }<br />
    };

    return new Handle(mFlinger, this);<br />
}</pre>
</div>
<p>没有什么东西，就是LayerCleaner，</p>
<p>它的设计目的就是SurfaceFlinger来清除图层。</p>
<p>所以我们可以得出结论</p>
<p>1）一个app对应一个surfaceFlinger,可以有多个layer，从而对应多个bufferqueue</p>
<p>2）surface的缓冲区内存是BufferQueue在进行dequeue的时候分配的，属于client端。</p>
<p>3）App &amp; SurfaceFlinger都通过bufferQueue来分配和使用缓冲区，所以互斥操作是由BufferQueue来实现。</p>
<p>参考：</p>
<p>《深入理解android内核设计思想》 林学森</p>
</div>
</div>
</div>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93y2gw8.html">jQuery&period;rotate&period;js参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93767g8.html">&lbrack;Xilinx&rsqb;Modelsim独立仿真Vivado生成的PLL核</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gglpl9.html">angular报&dollar;injector &sol; unpr的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mrr1r9.html">【C&num;】让工具栏ToolStrip能触发焦点控件的Leave、Validating、DataError等事件以验证数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j6xvlq.html">python操作excel表格&lpar;xlrd&sol;xlwt&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/390wrynq.html">virt-XXX</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdd5gy8.html">maven入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j00dyeq.html">jsp   颜色和表格控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w5jooq.html">C&num;文件系统管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn2rgv8.html">&lbrack;转&rsqb;pro&ast;c&sol;c&plus;&plus;编译错误 &rdquo; error&colon; sqlca&period;h&colon; No such file or directory &OpenCurlyDoubleQuote; 的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnl4ke8.html">AcmeAir安装AI探针--企业版</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ogzdj9.html">&lbrack;POJ2084&rsqb;Game of Connections</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd66yy8.html">IE的事件与w3c事件的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvggkjq.html">php扩展类开发实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgzyy78.html">python成长之路11</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjr1r38.html">DW3  消息推送</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pde7gd9.html">asp&period;net -mvc框架复习（3）-控制器和动作方法的任务分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jnklw8.html">php 链接mysql的三种方式对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyorg19.html">JAVA的第二次作业</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r57mreq.html">windows下cmd无法使用telnet命令解决方法 &lpar;原&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8ze62d8.html">MySQL 快速导入大量数据 资料收集</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8err0kq.html">SignalR入门之持久性连接</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv3nmo8.html">查看Eclipse版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96zkj4q.html">hibernate---注解--CascadeType属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93gryw8.html">通过参数传递，判断数字、字符串、list、tuple、词典等数据类型是否为可变数据对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8er63kq.html">项目总结笔记系列 Maven Session2</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8ze7yv8.html">Verilog学习笔记简单功能实现（四）&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;译码器和编码器</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gry34q.html">GIT 查看&sol;修改用户名和邮箱地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2y1v38.html">一次Debug过程的思考</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdryx08.html">【自然框架】终于把源码弄到git上了。</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
